function iif(condition, trueExpression, falseExpression)
	if condition then  
		return trueExpression
	else  
		return falseExpression
	end  
end

function ifnull(expression1, expression2)
	if expression1 == nil then  
		return expression2
	else  
		return expression1
	end  
end

function string.trim(s)
	return (s:gsub("^%s*(.-)%s*$", "%1"))
end

function MapExtension.Utils.Serialize(obj, path)
	local result = ""
	for k, v in pairs(obj) do
		local val = tostring(v)
		local name = iif(path == "", "", path .. ".") .. k
		if type(v) == "table" then
			result = result .. MapExtension.Utils.Serialize(v, name)
		else
			result = result .. name .. "=" .. val .. ","
		end
	end
	return result
end

function MapExtension.Utils.Deserialize(obj)
	local val = {}
	string.gsub(obj, "[,]?([^=]*)=([^,]*)", function (a,b) val[a]=b end)
	return val
end
